/*
 18.IX.2008                                              IndriScanfX.java
*/
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
// import java.awt.geom.*;
public class IndriScanfX {
   String Lin;
   String[] Tok;
   BufferedReader In;
   int IlTok, IndTok;
//   String Sep = ":|,|;|\\s+";
   String Sep = "\\s+";
   IndriScanfX(BufferedReader in) {
      In = in;
      IlTok = 0; IndTok = 1;
   }
   private void czytWiersz() throws IOException {
      boolean wczytano = false;
      do {
         try {
            Lin = In.readLine();
         } catch(IOException e) {
            throw new EOFException("Nieoczekiwany koniec pliku");
         }
       if(Lin == null)
            throw new EOFException("Nieoczekiwany koniec pliku");
         if (Lin.length() != 0) Lin = Lin.trim();
         if(Lin.length() == 0  || Lin.charAt(0) == '#')
            continue;
         Tok = Lin.split(Sep);
         IlTok = Tok.length; IndTok = 0;
         wczytano = true;
      } while (! wczytano);
   }
   public String pobierzLinie()  throws IOException {
      boolean wczytano = false;
      do {
         try {
            Lin = In.readLine();
         } catch(IOException e) {
            throw new EOFException("Bd odczytu pliku");
         }
         if(Lin == null) {
            wczytano = true;
         } else {
            if (Lin.length() != 0) Lin = Lin.trim();
            if(Lin.length() == 0  || Lin.charAt(0) == '#')
               continue;
            wczytano = true;
         }
      } while (! wczytano);
      IlTok = 0; IndTok = 1;
      return Lin;
   }
   public String czytStr() throws IOException {
      if(IndTok >= IlTok) {
         try {
            czytWiersz();
         } catch(IOException e) {
            throw e;
         }
      }
      String s1 = new String( Tok[IndTok] );
      IndTok++;
      return s1;
   }
   public int czytInt() throws IOException, IndriScanfExc {
      String s1;
      int k;
      try {
         s1 = czytStr();
      } catch(IOException e) {
         throw e;
      }
      try {
         k = Integer.parseInt(s1);
      } catch(NumberFormatException e) {
         throw new IndriScanfExc(s1, Lin);
      }
      return k;
   }
   public double czytDouble( ) throws IOException, IndriScanfExc  {
      String s1;
      double d;
      try {
         s1 = czytStr();
      } catch(IOException e) {
         throw e;
      }
      try {
         d = Double.parseDouble(s1);
      } catch(NumberFormatException e) {
         throw new IndriScanfExc(s1, Lin);
      }
      return d;
   }

   public void czytDoubles(double[]  d1)  throws IOException, IndriScanfExc {
      int i, n = d1.length;
      double d;
      for(i = 0; i < n; i++)  {
         String s1;
         try {
            s1 = czytStr();
         } catch(IOException e) {
            throw e;
         }
         try {
            d = Double.parseDouble(s1);
         } catch(NumberFormatException e) {
            throw new IndriScanfExc(s1, Lin);
         }
         d1[i] = d;
      }
   }
}
