//   1.IX.2006               ObrazEkranu.java
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.awt.geom.*;
import java.net.*;
import java.awt.image.*;
public class ObrazEkranu {
   BufferedImage Bim;
   WritableRaster Rast;
   ColorModel ColMod;
   int Szer, Wys;
   public ObrazEkranu(int szer, int wys) {
      Bim = new BufferedImage(szer, wys, BufferedImage.TYPE_INT_ARGB);
      Rast = Bim.getRaster();
      ColMod = Bim.getColorModel();
      Wys = Bim.getHeight();
      Szer = Bim.getWidth();
   }
   public void ustawPunkt(int x, int y, Color kolor) {
      if(x >= Szer || y >= Wys || x < 0 || y < 0)
         return;
      int argb = kolor.getRGB();
      Bim.setRGB( x, y, argb );
   }
   public BufferedImage Obraz() {
      return Bim;
   }
   public void zamienKolor(Color dawny, Color nowy) {
      if(Bim == null) return;
      int i,j;
      int argba,  argbs = dawny.getRGB(),  argbn = nowy.getRGB();
      for(i = 0; i < Wys; i++) {
         for(j = 0; j < Szer; j++) {
            argba = Bim.getRGB(j,i);
            if(argba == argbs) {
               Bim.setRGB(j, i, argbn);
            }
         }
      }
   }
   public Rectangle prawdziwyObraz(Color kolrys) {
      int x,y,argbo, argbr = kolrys.getRGB(),
          xmin = 0,ymin = 0, xmax = Szer-1, ymax = Wys-1;
      if(Bim == null) return new Rectangle();
      szuk_ymin: for(y = 0; y < Wys; y++) {
         for(x = 0; x < Szer; x++) {
            if(argbr != Bim.getRGB(x,y) ) continue;
            ymin = y;
//            System.out.println("ymin="+ymin);
            break szuk_ymin;
         }
      }
      szuk_xmin: for(x = 0; x < Szer; x++) {
         for(y = 0; y < Wys; y++) {
            if(argbr != Bim.getRGB(x,y) ) continue;
            xmin = x;
//            System.out.println("xmin="+xmin);
            break szuk_xmin;
         }
      }
      szuk_ymax: for(y = Wys-1; y >= 0; y--) {
         for(x = 0; x < Szer; x++) {
            if(argbr != Bim.getRGB(x,y) ) continue;
            ymax = y;
//            System.out.println("ymax="+ymax);
            break szuk_ymax;
         }
      }
      szuk_xmax: for(x = Szer-1; x >= 0; x--) {
         for(y = 0; y < Wys; y++) {
            if(argbr != Bim.getRGB(x,y) ) continue;
            xmax = x;
//            System.out.println("xmax="+xmax);
            break szuk_xmax;
         }
      }
      Rectangle r = new Rectangle(xmin, ymin, xmax-xmin, ymax-ymin);
//      System.out.println("xmin="+xmin+"  ymin="+ymin
//                        +"  xmax="+xmax+"  ymax="+ymax);

      return r;
   }
}
